<template>
    <div class="request-container" v-if="this.show">
        <Snackbar
                md-position="center"
                v-model="snack"
                :md-duration="durationTime"
                md-persistent
                class="error-snackbar"
        >
            <span>{{$t('main.errorHappened')}}</span>
            <MdButton class="md-raised details-button" @click="showDetails()">{{$t('main.errorShowDetails')}}</MdButton>
        </Snackbar>
        <div class="wrap" v-if="!error">
            <MdProgressSpinner :md-diameter="30" md-mode="indeterminate" :md-stroke="3" class="md-accent" />
            <div class="text">{{$t('main.requestInProgress')}}</div>
        </div>
    </div>
</template>
<script>
  import Vue from 'vue';
  import jsLog from 'js-logger';
  import Snackbar from './ModelSnackbar';
  import { MdDialog, MdProgress, MdButton } from 'vue-material/dist/components'
  import { TIME_TO_HIDE_ERROR_SNACKBAR_AUTOMATICALLY } from '../../Constants';

  Vue.use(MdDialog);
  Vue.use(MdProgress);
  Vue.use(MdButton);

  const log = jsLog.get('Request');

  export default {
    props: {
      show: {
        type: Boolean,
        isRequired: true
      }
    },
    computed: {
      error() {
        return this.$store.state.request && this.$store.state.request.error;
      },
      durationTime(){
        return TIME_TO_HIDE_ERROR_SNACKBAR_AUTOMATICALLY;
      },
      snack: {
        get() {
          const sn = this.error && this.error.showSnack;
          log.info('get', sn);
          return sn;
        },
        set(show) {
          // if request took more than 1000ms, this will not take any effect.
          // Snackbar was already removed from the Api. And even not removing from Api, would not take any effect.
          // this is why I had to remove from Api.
          log.info('close error from Request\'s snackbar timeout');
          this.$store.dispatch('closeErrorDetails');
          this.$forceUpdate();
        }
      },
      errorMessage() {
        return this.error && this.error.errorMsg;
      }
    },
    methods: {
      showDetails() {
        log.info('show details');
        this.$store.dispatch('hideSnack');
        this.$router.push({ query: { error: 'T' } });
      }
    },
    components: {
      Snackbar
    },
    updated() {
      log.info('updated');
    }
  }
</script>
<style scoped>
    .request-container {
        position: absolute;
        z-index: 1000;
        top: 0px;
        left: 0px;
        width: 100% !important;
        height: 100% !important;
        display: flex;
    }

    .wrap {
        background-color: white;
        opacity: 0.8;
        border: 1px solid grey;
        border-radius: 50%;
        width: 90px;
        height: auto;
        z-index: 1001;
        margin-left: auto !important;
        margin-right: auto !important;
        margin-top: auto;
        margin-bottom: auto;
        text-align: center;
    }

    .wrap > DIV {
        margin: 10px;
        stroke: grey;
    }

    .wrap > DIV > SVG > CIRCLE {
        stroke: grey !important;
    }

    .text {
        color: grey !important;
        font-size: 0.7em;
        margin-top: 0px !important;
        width: 50px;
        line-height: 12px;
        text-align: center;
        margin-left: auto !important;
        margin-right: auto !important;
    }

    .error-snackbar {
        background-color: var(--md-theme-default-fieldvariant) !important;
        z-index: 1001;
    }

    .details-button {
        color: var(--md-theme-default-fieldvariant) !important;
    }
</style>
